<CsoundSynthesizer>
<CsOptions>
-m128
</CsOptions>
<CsInstruments>

sr = 44100
ksmps = 32
nchnls = 2
0dbfs = 1

/* the final state of our granular machine.
try this:
- apply volume control with a slider
- control the grain size with another slider
- and the grain density with a third slider
- and the transposition with a fourth slider
- let the pointer move automatically in usual speed
- apply a speed change to the pointer (1=normal, 0=freeze, etc)
- load the "fox.wav" in another buffer and make possible to switch
  between this buffer and the live buffer
- find more possibilities and send it to me =)


	joachim with amin, arash, ghazaleh, parham, soheil, vahid
			tehran 2-4 sept 2018 */


;create a function table containing only zeros
giTable ftgen 0, 0, 60*sr, 2, 0

;what is the length of the table in seconds
giTableLenSec = ftlen(giTable) / sr



instr RecordToTable

 ;get the microphone input
 aInput inch 1
 
 ;create the pointer
 aPointer linseg 0, giTableLenSec, giTableLenSec*sr
 
 ;write the buffer
 tablew aInput, aPointer, giTable

endin
schedule "RecordToTable", 0, 60



instr Granular_machine
 
 ;get regularity (0) to irregularity (1)
 kIrregularity invalue "irregularity"

 ;grain density (initial value)
 kGrainDensity init 50
 
 ;grain size (initial value)
 kGrainSize init 50 ;ms
 
 ;transposition (cent)
 kTransCent init 0

 ;point to a position in the file
 kPoint invalue "pointer"
 
 ;let the metronom tick once every second
 kMetro metro kGrainDensity
 
 ;if the metronome ticks
 if kMetro == 1 then
 
  ;apply an offset for getting a-synchronous granular synthesis
  kOffset random 0, kGrainSize*kIrregularity
 
  ;we call the playing instrument
  event "i", "Play", kOffset/1000, kGrainSize/1000, kPoint*giTableLenSec, kTransCent
      
 endif

endin
schedule "Granular_machine", 0, 99999

instr Play

 iSkiptime = p4
 iTransCent = p5
 
 iSpeed = cent(iTransCent)
 iPhase = iSkiptime / giTableLenSec 
  
 ;use an interpolating oscillator to read the table
 aTable poscil3 1, iSpeed/giTableLenSec, giTable, iPhase

 aOut linen aTable, p3/2, p3, p3/2
 out aOut, aOut

endin

</CsInstruments>

<CsScore>

</CsScore>
</CsoundSynthesizer>
<bsbPanel>
 <label>Widgets</label>
 <objectName/>
 <x>483</x>
 <y>212</y>
 <width>320</width>
 <height>240</height>
 <visible>true</visible>
 <uuid/>
 <bgcolor mode="nobackground">
  <r>255</r>
  <g>255</g>
  <b>255</b>
 </bgcolor>
 <bsbObject type="BSBHSlider" version="2">
  <objectName>pointer</objectName>
  <x>24</x>
  <y>52</y>
  <width>267</width>
  <height>26</height>
  <uuid>{a7134430-aaf7-4afb-bb63-74af27851394}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <minimum>0.00000000</minimum>
  <maximum>1.00000000</maximum>
  <value>0.25842697</value>
  <mode>lin</mode>
  <mouseControl act="jump">continuous</mouseControl>
  <resolution>-1.00000000</resolution>
  <randomizable group="0">false</randomizable>
 </bsbObject>
 <bsbObject type="BSBLabel" version="2">
  <objectName/>
  <x>30</x>
  <y>12</y>
  <width>75</width>
  <height>30</height>
  <uuid>{67383543-345b-4762-a0d5-72839d0b226c}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>-3</midicc>
  <label>Pointer</label>
  <alignment>left</alignment>
  <font>sans</font>
  <fontsize>20</fontsize>
  <precision>3</precision>
  <color>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject type="BSBDisplay" version="2">
  <objectName>pointer</objectName>
  <x>183</x>
  <y>13</y>
  <width>79</width>
  <height>33</height>
  <uuid>{f63f6752-32d8-42c7-b58e-0e3e169eb3d4}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>-3</midicc>
  <label>0.258</label>
  <alignment>left</alignment>
  <font>sans</font>
  <fontsize>20</fontsize>
  <precision>3</precision>
  <color>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>border</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject type="BSBHSlider" version="2">
  <objectName>irregularity</objectName>
  <x>26</x>
  <y>133</y>
  <width>267</width>
  <height>26</height>
  <uuid>{c9ff6404-3085-432c-a430-0fd23e1a4e09}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <minimum>0.00000000</minimum>
  <maximum>1.00000000</maximum>
  <value>0.17977528</value>
  <mode>lin</mode>
  <mouseControl act="jump">continuous</mouseControl>
  <resolution>-1.00000000</resolution>
  <randomizable group="0">false</randomizable>
 </bsbObject>
 <bsbObject type="BSBLabel" version="2">
  <objectName/>
  <x>32</x>
  <y>93</y>
  <width>125</width>
  <height>30</height>
  <uuid>{c3b16b59-9e3c-4751-bbcc-ffa201bbb64d}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>-3</midicc>
  <label>Irregularity</label>
  <alignment>left</alignment>
  <font>sans</font>
  <fontsize>20</fontsize>
  <precision>3</precision>
  <color>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject type="BSBDisplay" version="2">
  <objectName>irregularity</objectName>
  <x>185</x>
  <y>94</y>
  <width>79</width>
  <height>33</height>
  <uuid>{df8bf007-a34b-4b6c-ac4b-2e97030ff4e8}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>-3</midicc>
  <label>0.180</label>
  <alignment>left</alignment>
  <font>sans</font>
  <fontsize>20</fontsize>
  <precision>3</precision>
  <color>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>border</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
</bsbPanel>
<bsbPresets>
</bsbPresets>
